> For the complete documentation index, see [llms.txt](https://docs.hackle.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.hackle.io/en/development-guide/ios/ios-user-explorer.md).

# User Explorer

{% hint style="info" %}
**Recommended for Debug builds only.**
{% endhint %}

{% hint style="warning" %}
The User Explorer is not available in remote evaluation mode.
{% endhint %}

This guide explains how to check User Identifiers and force-assign users to A/B Tests and Feature Flags.

Add the following code.

```swift
override func viewDidLoad() {
  // ...
  hackleApp.showUserExplorer()
  // ...
}
```

A Hackle logo button is displayed at the bottom of the screen. Clicking the button takes you to the settings screen.

![](https://143363954-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FyAVlNQhS253reum0Ce94%2Fuploads%2Fgit-blob-d6a21e1f3662fc16ed430de20ae9f7e4693af840%2F21c3290-_2023-03-31__12.55.54_208c1bf53482e232.png?alt=media)

## Check User Identifier

You can view and copy the User Identifier at the top of the screen.

If the SDK version supports Push Messages, you can also view the push token information.

![](https://143363954-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FyAVlNQhS253reum0Ce94%2Fuploads%2Fgit-blob-a5bc269ffe4a1e56bc5561710c3b4c817a1e876d%2F8eb0ea9-IMG_5F76D48B9E34-1_703198445f4a586d.jpeg?alt=media)

## Force Assignment

* You can view the distribution results for A/B Tests and Feature Flags at the bottom of the screen.
* Click a SelectBox to force-assign to a specific variation.
* Click the `Reset` button to remove the force assignment.
* Click `Reset all` to remove all force assignments.
* Force assignments made in the app only apply when distribution is performed in the app. (They are not registered as Test Devices in the Dashboard.)
* If a force assignment is not applied, fully close the app and relaunch it.

![](https://143363954-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FyAVlNQhS253reum0Ce94%2Fuploads%2Fgit-blob-600d97815f0b0b8f403bea5b4b132f810f7ae436%2Fa066766-ab_a39433ad94414a25.png?alt=media)

![](https://143363954-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FyAVlNQhS253reum0Ce94%2Fuploads%2Fgit-blob-ff408c2a9179dc4e864c57879445320509b1ce58%2Fb5972f8-ff_4c56c45869cd004f.png?alt=media)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.hackle.io/en/development-guide/ios/ios-user-explorer.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
